diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuAbstract.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuAbstract.java
index 21e256655..f558bd76f 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuAbstract.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuAbstract.java
@@ -710,12 +710,12 @@ public abstract class MenuAbstract
 				final var srcStack = slot.getItemStack();
 				if (srcStack == null) {
 					final var stack = draggingItemStack.copy();
-					stack.stackSize = stack.getMaxStackSize();
+					stack.stackSize = Math.min(stack.getMaxStackSize(), slot.getMaxStackSize());
 					slot.set(stack);
 					slot.setChanged();
 				} else {
 					if (!srcStack.canStackWith(draggingItemStack)) continue;
-					srcStack.stackSize = srcStack.getMaxStackSize();
+					srcStack.stackSize = Math.min(srcStack.getMaxStackSize(), slot.getMaxStackSize());
 					slot.setChanged();
 				}
 			}
@@ -747,7 +747,7 @@ public abstract class MenuAbstract
 			int amount = itemsPerSlot;
 			amount = Math.min(amount, slot.getMaxStackSize());
 			if(stackInSlot != null) {
-				amount = Math.min(amount, stackInSlot.getMaxStackSize() - stackInSlot.stackSize);
+				amount = Math.min(amount, Math.min(stackInSlot.getMaxStackSize(), slot.getMaxStackSize()) - stackInSlot.stackSize);
 			}
 			amount = Math.min(amount, draggingItemStack.stackSize);
 			if(amount <= 0) {
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/slot/SlotResult.java b/game/core/src/main/java/net/minecraft/core/player/inventory/slot/SlotResult.java
index 3e57f99a4..6bd157f89 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/slot/SlotResult.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/slot/SlotResult.java
@@ -3,6 +3,7 @@ package net.minecraft.core.player.inventory.slot;
 import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.data.registry.Registries;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryCrafting;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.*;
 import net.minecraft.core.item.tool.ItemToolHoe;
@@ -10,6 +11,7 @@ import net.minecraft.core.item.tool.ItemToolPickaxe;
 import net.minecraft.core.item.tool.ItemToolSword;
 import net.minecraft.core.player.inventory.container.Container;
 import net.minecraft.core.player.inventory.container.ContainerCrafting;
+import org.jetbrains.annotations.Nullable;
 
 public class SlotResult extends Slot
 {
@@ -60,7 +62,16 @@ public class SlotResult extends Slot
 				|| itemStack.itemID == Items.ARMOR_LEGGINGS_CHAINMAIL.id) {
 			thePlayer.addStat(Achievements.REPAIR_ARMOR, 1);
 		}
+		if(item.id == Items.INGOT_STEEL.id) thePlayer.addStat(Achievements.OBTAIN_STEEL, 1);
+		if(item.id == Items.BUCKET_STEEL.id) thePlayer.addStat(Achievements.CRAFT_STEEL_BUCKET, 1);
+		if(item.id == Blocks.CONDUIT.id()) thePlayer.addStat(Achievements.CRAFT_CONDUIT, 1);
 
+		if (!thePlayer.world.isClientSide) {
+			final @Nullable RecipeEntryCrafting<?, ?> recipe = Registries.RECIPES.findMatchingCraftingRecipe((ContainerCrafting) craftSlots);
+			if (recipe != null && recipe.toString().startsWith("minecraft:workbench/acid_conversion_")) {
+				thePlayer.addStat(Achievements.CRAFT_ACID_COBBLE_TO_STONE, 1);
+			}
+		}
 		Registries.RECIPES.onCraftResult((ContainerCrafting) craftSlots);
 	}
     
diff --git a/game/core/src/main/java/net/minecraft/core/world/Explosion.java b/game/core/src/main/java/net/minecraft/core/world/Explosion.java
index 9fd51bf2c..7a0caad5e 100644
--- a/game/core/src/main/java/net/minecraft/core/world/Explosion.java
+++ b/game/core/src/main/java/net/minecraft/core/world/Explosion.java
@@ -25,7 +25,7 @@ public class Explosion {
     protected final @NotNull World world;
     public final @Nullable Entity exploder;
     public boolean isFlaming;
-    protected Random ExplosionRNG;
+    protected Random explosionRNG;
     public double explosionX;
     public double explosionY;
     public double explosionZ;
@@ -35,7 +35,7 @@ public class Explosion {
 
     public Explosion(@NotNull World world, @Nullable Entity exploder, double x, double y, double z, float explosionSize) {
         this.isFlaming = false;
-        this.ExplosionRNG = new Random();
+        this.explosionRNG = new Random();
         this.destroyedBlockPositions = new HashSet<>();
         this.world = world;
         this.exploder = exploder;
@@ -175,7 +175,7 @@ public class Explosion {
                     float proc = 1 - (((IArmorWearing<?>) entity).getTotalProtectionAmount(DamageType.BLAST) / 2f);
                     flingForce *= proc;
                 }
-                if (!entity.noPhysics) {
+                if (!entity.hasNoPhysics()) {
                     entity.fling(xComp * flingForce, yComp * flingForce, zComp * flingForce, 1);
                 }
             }
@@ -191,7 +191,7 @@ public class Explosion {
             int y1 = chunkposition.y;
             int z1 = chunkposition.z;
 
-            if (this.world.getBlockId(x1, y1, z1) == Blocks.AIR.id() && Blocks.solid[this.world.getBlockId(x1, y1 - 1, z1)] && this.ExplosionRNG.nextInt(3) == 0) {
+            if (this.world.getBlockId(x1, y1, z1) == Blocks.AIR.id() && Blocks.solid[this.world.getBlockId(x1, y1 - 1, z1)] && this.explosionRNG.nextInt(3) == 0) {
                 this.world.setBlockWithNotify(x1, y1, z1, Blocks.FIRE.id());
             }
         }
diff --git a/game/core/src/main/java/net/minecraft/core/world/ExplosionCannonball.java b/game/core/src/main/java/net/minecraft/core/world/ExplosionCannonball.java
index a00844f49..c9f9b2674 100644
--- a/game/core/src/main/java/net/minecraft/core/world/ExplosionCannonball.java
+++ b/game/core/src/main/java/net/minecraft/core/world/ExplosionCannonball.java
@@ -53,7 +53,7 @@ public class ExplosionCannonball extends Explosion {
                     float proc = 1 - entArmored.getTotalProtectionAmount(DamageType.BLAST) / 2f;
                     flingForce *= proc;
                 }
-                if (!entity.noPhysics) {
+                if (!entity.hasNoPhysics()) {
                     entity.fling(xComp * flingForce, yComp * flingForce, zComp * flingForce, 1);
                 }
             }
@@ -69,9 +69,9 @@ public class ExplosionCannonball extends Explosion {
             Vector3d d = new Vector3d(0, 0, 1);
             for (int i = 0; i < 64; i++) {
                 d.set(0, 0, 0.25);
-                d.rotateY(ExplosionRNG.nextDouble() * Math.PI_TIMES_2);
-                d.rotateX(ExplosionRNG.nextDouble() * Math.PI_TIMES_2);
-                d.mul(1 - ExplosionRNG.nextDouble() * 0.25d);
+                d.rotateY(explosionRNG.nextDouble() * Math.PI_TIMES_2);
+                d.rotateX(explosionRNG.nextDouble() * Math.PI_TIMES_2);
+                d.mul(1 - explosionRNG.nextDouble() * 0.25d);
                 this.world.spawnParticle("explode", this.explosionX + d.x(), this.explosionY + d.y(), this.explosionZ + d.z(), d.x() * 2, d.y() * 2, d.z() * 2, 0, false);
                 this.world.spawnParticle("smoke", this.explosionX + d.x(), this.explosionY + d.y(), this.explosionZ + d.z(), d.x() * 2, d.y() * 2, d.z() * 2, 0, false);
             }
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderNether.java b/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderNether.java
index 199476ffc..3f5b4bce2 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderNether.java
@@ -176,14 +176,12 @@ public final class BiomeProviderNether extends BiomeProvider {
                 0.5, 1.0,
                 0.0, 1.0));
 
-        // Mid/Warm Biome
         brm.addRange(Biomes.NETHER_SHELF, new BiomeRange(
                 0.70, 0.75,
                 0.0, 1.0,
                 0.5, 1.0,
                 0.0, 1.0));
 
-        // Mid/Cool Biomes
         brm.addRange(Biomes.NETHER_CRYSTAL_FOREST, new BiomeRange(
                 0.45, 0.70,
                 0.1, 1.0,
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/LavaFloeLargeFeature.java b/game/core/src/main/java/net/minecraft/core/world/generate/LavaFloeLargeFeature.java
index 0358fc8aa..0108944dd 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/LavaFloeLargeFeature.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/LavaFloeLargeFeature.java
@@ -74,7 +74,8 @@ public class LavaFloeLargeFeature
                             if(random.nextInt(20) == 0) {
                                 this.trySetBlock(result, x, y, z, Blocks.PUMICE_WET.id());
                             } else {
-                                this.trySetBlock(result, x, y, z, Blocks.COBBLE_NETHERRACK.id());
+                                int floeBlockId = random.nextInt(2) == 0 ? Blocks.NETHERRACK.id() : Blocks.COBBLE_NETHERRACK.id();
+                                this.trySetBlock(result, x, y, z, floeBlockId);
                             }
                         }
                         for (int y = oceanY + (int) (height - 2); y < oceanY + (height + 1); y++) {
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/RubyglassFloeLargeFeature.java b/game/core/src/main/java/net/minecraft/core/world/generate/RubyglassFloeLargeFeature.java
index 39cb00389..9d4f333b3 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/RubyglassFloeLargeFeature.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/RubyglassFloeLargeFeature.java
@@ -63,7 +63,8 @@ public class RubyglassFloeLargeFeature extends LargeFeature {
 						}
 
 						for (int y = oceanY; y < oceanY + depth; ++y) {
-							this.trySetBlock(result, x, y, z, Blocks.COBBLE_NETHERRACK.id());
+							int floeBlockId = random.nextInt(2) == 0 ? Blocks.NETHERRACK.id() : Blocks.COBBLE_NETHERRACK.id();
+							this.trySetBlock(result, x, y, z, floeBlockId);
 						}
 					}
 				}
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java
index efa7e670d..b1d2967af 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java
@@ -3,6 +3,8 @@ package net.minecraft.core.world.generate.chunk.perlin.nether;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicOreNetherCoal;
 import net.minecraft.core.block.BlockLogicNodeRubyglass;
+import net.minecraft.core.block.BlockLogicSoulSand;
+import net.minecraft.core.block.BlockLogicSulfur;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
@@ -113,6 +115,28 @@ public class ChunkDecoratorNether
                 .withPositionSelector(PositionSelectors.HeightRangeUniform)
                 .withPlacementMethod(new PlacementMethod.TriesPerChunk(1000)));
 
+        this.register("minecraft:decoration/nether/default/sulfur_pocket", (new ChunkDecorationBuilder(new WorldFeatureOre(BlockLogicSulfur.pocketVariantMap, 24)))
+                .withBiomeMask(new Biome[]{Biomes.NETHER_SULFUR_POOLS})
+                .withPositionSelector(PositionSelectors.HeightRangeUniform)
+                .withPlacementMethod((feature, world, chunk, random) -> {
+                    int rangeY = world.getWorldType().getMaxY(world) - world.getWorldType().getMinY(world) + 1;
+                    int tries = (int) (20 * (rangeY / 128f));
+                    for (int i = 0; i < tries; i++) {
+                        feature.placeFeature(world, chunk, random);
+                    }
+                }));
+
+        this.register("minecraft:decoration/nether/default/soulsand_pocket", (new ChunkDecorationBuilder(new WorldFeatureOre(BlockLogicSoulSand.pocketVariantMap, 32)))
+                .withBiomeMask(new Biome[]{Biomes.NETHER_OLD_WORLD, Biomes.NETHER_OLD_WORLD_DESERT})
+                .withPositionSelector(PositionSelectors.HeightRangeUniform)
+                .withPlacementMethod((feature, world, chunk, random) -> {
+                    int rangeY = world.getWorldType().getMaxY(world) - world.getWorldType().getMinY(world) + 1;
+                    int tries = (int) (20 * (rangeY / 128f));
+                    for (int i = 0; i < tries; i++) {
+                        feature.placeFeature(world, chunk, random);
+                    }
+                }));
+
         // Water Features
         this.register("minecraft:decoration/nether/default/water_spring", (new ChunkDecorationBuilder(new WorldFeatureNetherSpring(Blocks.FLUID_WATER_FLOWING.id())))
                 .withBiomeMask(new Biome[]{Biomes.NETHER_CRYSTAL_FOREST, Biomes.NETHER_CRYSTAL_PLAINS})
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java
index 367b6cf12..b75207a26 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java
@@ -32,6 +32,7 @@ public class SurfaceGeneratorNether implements SurfaceGenerator {
     private final short cobbleNetherrackId = (short) Blocks.COBBLE_NETHERRACK.id();
     private final short cobbleNetherrackCrystallineId = (short) Blocks.COBBLE_NETHERRACK_CRYSTALLINE.id();
     private final short cobbleGloomstoneId = (short) Blocks.COBBLE_GLOOMSTONE.id();
+    private final short gloomstoneId = (short) Blocks.GLOOMSTONE.id();
     private final short glowstoneId = (short) Blocks.GLOWSTONE.id();
     private final short ashId = (short) Blocks.BLOCK_ASH.id();
     private final short slateId = (short) Blocks.SLATE.id();
@@ -139,7 +140,7 @@ public class SurfaceGeneratorNether implements SurfaceGenerator {
                             } else if (biome == Biomes.NETHER_SULFUR_POOLS) {
                                 fillerBlock = sulfurId;
                             } else if (biome == Biomes.NETHER_OLD_WORLD || biome == Biomes.NETHER_OLD_WORLD_DESERT) {
-                                fillerBlock = cobbleGloomstoneId;
+                                fillerBlock = (rand.nextInt(2) == 0) ? gloomstoneId : cobbleGloomstoneId;
                             } else {
                                 fillerBlock = netherrackId;
                             }
@@ -164,16 +165,16 @@ public class SurfaceGeneratorNether implements SurfaceGenerator {
                         currentLayerDepth = soilThickness + 2;
 
                         if (y >= absoluteOceanY - 1) {
-                            result.setBlock(x, y, z, this.cragOrShelfFloorMixIfCobble(biome, topBlock, rand));
+                            result.setBlock(x, y, z, this.mixStoneVariant(biome, topBlock, rand));
                         } else {
                             // if the block is below ocean level, set it to the chosen filler block
-                            result.setBlock(x, y, z, this.cragOrShelfFloorMixIfCobble(biome, fillerBlock, rand));
+                            result.setBlock(x, y, z, this.mixStoneVariant(biome, fillerBlock, rand));
                         }
                         continue;
                     }
 
                     if (currentLayerDepth > 0) {
-                        result.setBlock(x, y, z, this.cragOrShelfFloorMixIfCobble(biome, fillerBlock, rand));
+                        result.setBlock(x, y, z, this.mixStoneVariant(biome, fillerBlock, rand));
                         currentLayerDepth--;
                     }
 
@@ -184,9 +185,10 @@ public class SurfaceGeneratorNether implements SurfaceGenerator {
 
                     if (this.generateStoneVariants && currentLayerDepth <= 0) {
                         int stoneBlockId = cachedBiomeStoneBlockId;
-                        // Crag/shelf is the only biome with a randomized variant per block.
                         if (biome == Biomes.NETHER_CRAG || biome == Biomes.NETHER_SHELF) {
                             stoneBlockId = (rand.nextInt(2) == 0) ? netherrackId : cobbleNetherrackId;
+                        } else if (biome == Biomes.NETHER_OLD_WORLD || biome == Biomes.NETHER_OLD_WORLD_DESERT) {
+                            stoneBlockId = (rand.nextInt(2) == 0) ? gloomstoneId : cobbleGloomstoneId;
                         }
                         result.setBlock(x, y, z, stoneBlockId);
                     }
@@ -195,11 +197,15 @@ public class SurfaceGeneratorNether implements SurfaceGenerator {
         }
     }
 
-    private short cragOrShelfFloorMixIfCobble(final @NotNull Biome biome, final short blockId, final @NotNull Random rand) {
-        if ((biome != Biomes.NETHER_CRAG && biome != Biomes.NETHER_SHELF) || blockId != this.cobbleNetherrackId) {
-            return blockId;
+    private short mixStoneVariant(final @NotNull Biome biome, final short blockId, final @NotNull Random rand) {
+        if ((biome == Biomes.NETHER_CRAG || biome == Biomes.NETHER_SHELF || biome == Biomes.NETHER_CRYSTAL_PLAINS || biome == Biomes.NETHER_CRYSTAL_FOREST) && blockId == this.cobbleNetherrackId) {
+            return rand.nextInt(2) == 0 ? this.netherrackId : this.cobbleNetherrackId;
         }
-        return (short) (rand.nextInt(2) == 0 ? this.netherrackId : this.cobbleNetherrackId);
+        if ((biome == Biomes.NETHER_OLD_WORLD || biome == Biomes.NETHER_OLD_WORLD_DESERT)
+            && (blockId == this.cobbleGloomstoneId || blockId == this.gloomstoneId)) {
+            return rand.nextInt(2) == 0 ? this.gloomstoneId : this.cobbleGloomstoneId;
+        }
+        return blockId;
     }
 
     private int computeBiomeStoneBlock(Biome biome, int worldFillBlock) {
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java
index 79450252d..0d0b35cb0 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java
@@ -24,6 +24,7 @@ public class TerrainGeneratorNether extends TerrainGeneratorLerp {
     private final int fillerBlockId;
     private final int lavaId;
     private final int cobbleNetherrackId;
+    private final int netherrackId;
     private final int obsidianId;
 
     private final ThreadLocal<int[]> oceanFluidByXZ = ThreadLocal.withInitial(() -> new int[256]);
@@ -45,6 +46,7 @@ public class TerrainGeneratorNether extends TerrainGeneratorLerp {
         this.waterId = Blocks.FLUID_WATER_STILL.id();
         this.lavaId = Blocks.FLUID_LAVA_STILL.id();
         this.cobbleNetherrackId = Blocks.COBBLE_NETHERRACK.id();
+        this.netherrackId = Blocks.NETHERRACK.id();
         this.obsidianId = Blocks.OBSIDIAN.id();
 
         this.oceanY = world.getWorldType().getOceanY();
@@ -98,6 +100,10 @@ public class TerrainGeneratorNether extends TerrainGeneratorLerp {
                 return this.rubyglassId;
             }
 
+            if (fluidId == this.cobbleNetherrackId) {
+                return this.rand.nextInt(2) == 0 ? this.netherrackId : this.cobbleNetherrackId;
+            }
+
             return fluidId;
         } else {
             return this.airId;
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeaturePillar.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeaturePillar.java
index df53c5ce8..f66d83ca7 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeaturePillar.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeaturePillar.java
@@ -151,7 +151,10 @@ public class WorldFeaturePillar
                         int xW = x0 + MathHelper.floor(t[0]);
                         int yW = y0 + MathHelper.floor(t[1]);
                         int zW = z0 + MathHelper.floor(t[2]);
-                        world.setBlockWithNotify(xW, yW, zW, blockId);
+                        int placed = (blockId == Blocks.COBBLE_NETHERRACK.id() && random.nextInt(2) == 0)
+                            ? Blocks.NETHERRACK.id()
+                            : blockId;
+                        world.setBlockWithNotify(xW, yW, zW, placed);
                     }
                 }
             }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureRoofSpire.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureRoofSpire.java
index d60ce0ab1..82229f5e4 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureRoofSpire.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureRoofSpire.java
@@ -23,6 +23,8 @@ public class WorldFeatureRoofSpire extends WorldFeature {
 			pos.up();
 		}
 
+		final boolean randomizeCobbleNetherrack = boulderBlock == Blocks.COBBLE_NETHERRACK;
+
 		if (this.hasSpace(world, pos.x, pos.y, pos.z)) {
 			Vector3i highestOffset = new Vector3i(0, 0, 0);
 			TilePos centerPos = new TilePos(pos.x, pos.y, pos.z);
@@ -41,7 +43,7 @@ public class WorldFeatureRoofSpire extends WorldFeature {
 						Block<?> currentBlock = world.getBlockType(queryPos);
 
 						if (currentBlock != Blocks.BEDROCK) {
-							world.setBlockType(queryPos, boulderBlock);
+							world.setBlockType(queryPos, pickSpireBlock(randomizeCobbleNetherrack, random));
 						}
 					}
 				}
@@ -49,13 +51,20 @@ public class WorldFeatureRoofSpire extends WorldFeature {
 
 			for (int y1 = 0; y1 < 2; ++y1) {
 				centerPos.add(highestOffset.x, -(highestOffset.y + y1), highestOffset.z, queryPos);
-				world.setBlockType(queryPos, boulderBlock);
+				world.setBlockType(queryPos, pickSpireBlock(randomizeCobbleNetherrack, random));
 			}
 		}
 
 		return true;
 	}
 
+	private Block<?> pickSpireBlock(boolean randomizeCobbleNetherrack, Random random) {
+		if (randomizeCobbleNetherrack && random.nextInt(2) == 0) {
+			return Blocks.NETHERRACK;
+		}
+		return boulderBlock;
+	}
+
 	private boolean hasSpace(World world, int xc, int y, int zc) {
 		TilePos queryPos = new TilePos();
 
diff --git a/game/core/src/main/resources/assets/minecraft/lang/en_US/command.lang b/game/core/src/main/resources/assets/minecraft/lang/en_US/command.lang
index 9c29fc03c..a22884b0d 100644
--- a/game/core/src/main/resources/assets/minecraft/lang/en_US/command.lang
+++ b/game/core/src/main/resources/assets/minecraft/lang/en_US/command.lang
@@ -67,6 +67,11 @@ command.commands.achievement.grant.success_multiple_entities=Granted achievement
 command.commands.achievement.grant.success_single_entity=Granted achievement §5[%s]§r to %s
 command.commands.achievement.grant.all.success_multiple_entities=Granted all achievements to %s entities
 command.commands.achievement.grant.all.success_single_entity=Granted all achievements to %s
+command.commands.achievement.revoke.exception_does_not_have_achievement=Player does not have achievement
+command.commands.achievement.revoke.success_multiple_entities=Revoked achievement §5[%s]§r from %s entities
+command.commands.achievement.revoke.success_single_entity=Revoked achievement §5[%s]§r from %s
+command.commands.achievement.revoke.all.success_multiple_entities=Revoked all achievements from %s entities
+command.commands.achievement.revoke.all.success_single_entity=Revoked all achievements from %s
 command.commands.seed.success=Seed: §5[%s]§r
 command.commands.seed.copied_to_clipboard=Copied to clipboard!
 command.commands.clear.success_single_item_single_entity=%s item slot cleared
diff --git a/game/core/src/main/resources/assets/minecraft/lang/en_US/gui.lang b/game/core/src/main/resources/assets/minecraft/lang/en_US/gui.lang
index 8d0e43643..de2a55a7a 100644
--- a/game/core/src/main/resources/assets/minecraft/lang/en_US/gui.lang
+++ b/game/core/src/main/resources/assets/minecraft/lang/en_US/gui.lang
@@ -7,6 +7,8 @@ gui.achievements.button.done=Done
 gui.achievements.label.title=Achievements
 gui.achievements.label.taken=Taken!
 gui.achievements.label.requires=Requires '%1$s'
+gui.achievements.label.secret=???
+gui.achievements.label.secret.desc=???
 gui.achievements.label.completion=%1$s Complete!
 
 gui.achievements.page.vanilla.name=Vanilla
@@ -273,6 +275,10 @@ gui.options.page.debug.category.test=Tests
 gui.options.page.debug.button.open.model_viewer=Open Model Viewer
 gui.options.page.debug.button.open.biome_finder=Open Seed Viewer
 gui.options.page.debug.button.open.datadumper=Run Data Dumper
+gui.options.page.debug.button.dump.wiki=Dump Formatted Wiki Data
+gui.options.page.debug.button.dump.invsprite=Dump InvSprites PNG
+gui.options.page.debug.button.dump.invsprite_apng=Dump InvSprites Animated PNG
+gui.options.page.debug.button.dump.invsprite.tooltip=Load a world first: \n Biome and season colors only render in-world.
 gui.options.page.debug.button.open.sound_test=Open Sound Test
 gui.options.page.debug.button.open.texture_viewer=Open Texture Viewer
 gui.options.page.debug.button.open.font_tester=Open Font Test
diff --git a/game/core/src/main/resources/assets/minecraft/lang/en_US/stats.lang b/game/core/src/main/resources/assets/minecraft/lang/en_US/stats.lang
index 0a3bad62e..ce960cede 100644
--- a/game/core/src/main/resources/assets/minecraft/lang/en_US/stats.lang
+++ b/game/core/src/main/resources/assets/minecraft/lang/en_US/stats.lang
@@ -124,4 +124,36 @@ achievement.fastTravel.desc=Use the Nether to travel more than 8000 blocks in th
 achievement.blastFurnace=Blast Processing
 achievement.blastFurnace.desc=Construct a blast furnace out of eight iron bars and nether coal.
 achievement.obtainSteel=What a Steel!
-achievement.obtainSteel.desc=Combine coal and iron to acquire steel, a strong alloy.
\ No newline at end of file
+achievement.obtainSteel.desc=Combine coal and iron to acquire steel, a strong alloy.
+achievement.craftSteelBucket=Heavy Haul
+achievement.craftSteelBucket.desc=Craft a steel bucket.
+achievement.discoverSulfurPools=Something Smells...
+achievement.discoverSulfurPools.desc=Discover the Sulfur Pools.
+achievement.discoverVolcanicIslands=Having a Blast
+achievement.discoverVolcanicIslands.desc=Discover the Volcanic Islands.
+achievement.flingVent=Blasting off Again!
+achievement.flingVent.desc=Stand atop a thermal vent as it goes off.
+achievement.collectPumice=Hidden Pores
+achievement.collectPumice.desc=Collect a block of molten pumice.
+achievement.explodeStackedVent=What was that?
+achievement.explodeStackedVent.desc=Place a thermal vent on top of another in the overworld and wait for it to erupt.
+achievement.discoverCrystalForest=BzZzZzt!
+achievement.discoverCrystalForest.desc=Discover the Crystal Forest.
+achievement.collectRubyglass=Crystalline Harvest
+achievement.collectRubyglass.desc=Collect rubyglass from a crystal node.
+achievement.craftConduit=Go with the Flow
+achievement.craftConduit.desc=Craft a conduit.
+achievement.discoverOldWorld=Uncanny...
+achievement.discoverOldWorld.desc=Discover the Old World.
+achievement.triggerEmber=Suprise!
+achievement.triggerEmber.desc=Trigger an ember block to exlode by walking ontop of it.
+achievement.collectAcid=Acquire Acid
+achievement.collectAcid.desc=Collect acid in a bucket.
+achievement.acidSulfurConversion=Caustic Cooling
+achievement.acidSulfurConversion.desc=Convert acid to sulfur with water in the overworld.
+achievement.acidStoneGeneration=Smooth Operator
+achievement.acidStoneGeneration.desc=Use acid to harden fluids into smooth stone.
+achievement.acidCobbleConversion=Reconstitution
+achievement.acidCobbleConversion.desc=Mix acid with cobble or sand in the workbench.
+achievement.acidBath=Garra Acida
+achievement.acidBath.desc=Sit in acid for more than 10 seconds.
\ No newline at end of file
diff --git a/game/core/src/main/resources/assets/minecraft/lang/en_US/tile.lang b/game/core/src/main/resources/assets/minecraft/lang/en_US/tile.lang
index a92cd646b..b13a636c7 100644
--- a/game/core/src/main/resources/assets/minecraft/lang/en_US/tile.lang
+++ b/game/core/src/main/resources/assets/minecraft/lang/en_US/tile.lang
@@ -1549,6 +1549,22 @@ tile.statue.pigman.lower.name=Pigman Statue (Lower)
 tile.statue.pigman.lower.desc=How?
 tile.statue.pigman.upper.name=Pigman Statue (Upper)
 tile.statue.pigman.upper.desc=How?
+tile.statue.slate.lower.name=Slate Statue (Lower)
+tile.statue.slate.lower.desc=How?
+tile.statue.slate.upper.name=Slate Statue (Upper)
+tile.statue.slate.upper.desc=How?
+tile.statue.permafrost.lower.name=Permafrost Statue (Lower)
+tile.statue.permafrost.lower.desc=How?
+tile.statue.permafrost.upper.name=Permafrost Statue (Upper)
+tile.statue.permafrost.upper.desc=How?
+tile.statue.netherrack.lower.name=Netherrack Statue (Lower)
+tile.statue.netherrack.lower.desc=How?
+tile.statue.netherrack.upper.name=Netherrack Statue (Upper)
+tile.statue.netherrack.upper.desc=How?
+tile.statue.gloomstone.lower.name=Gloomstone Statue (Lower)
+tile.statue.gloomstone.lower.desc=How?
+tile.statue.gloomstone.upper.name=Gloomstone Statue (Upper)
+tile.statue.gloomstone.upper.desc=How?
 
 tile.matcher.name=Matcher
 tile.matcher.desc=Matches the block in front to the block behind.
